;-------------------------------------------------------------
;+
; NAME:
;       MOREHIST
; PURPOSE:
;       This routine creates a widget based interface for editing minimum and
;       maximum time of histogram values
; MAIN PROGRAM:
;       SLAP - program for testing SEISMOLAP 
;       SEISMOLAP was developed by Jochen Zschau,
;       Geoforschungszentrum Potsdam, Germany
; MODIFICATION HISTORY:
;       Matthias Liebetanz, TH-Darmstadt, Germany, 17. Apr 1998 .
;
;       No warranty that this program is free of error
;-
;-------------------------------------------------------------
PRO MOREHIST,GROUP=Group,$
            MAGMIN = magmin, $
            MAGMAX = magmax, $
            ZMIN = zmin, $
            ZMAX = zmax, $
            QUALMIN = qualmin, $
            QUALMAX = qualmax

magmin_old = magmin
magmax_old = magmax

zmin_old = zmin
zmax_old = zmax

qualmin_old = qualmin
qualmax_old = qualmax

IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

altered=0

MAIN13 = WIDGET_BASE(GROUP_LEADER=Group, $
      COLUMN=1, $
      MAP=1, $
      TITLE='Borders:', $
      UVALUE='MAIN13')

  FIELD_MAGMIN = CW_FIELD(MAIN13,TITLE = 'Min Magnitude', /FLOAT, VALUE = magmin, UVALUE = 'FIELD_MAGMIN', /ALL_EVENTS)
  FIELD_MAGMAX = CW_FIELD(MAIN13,TITLE = 'Max Magnitude', /FLOAT, VALUE = magmax, UVALUE = 'FIELD_MAGMAX', /ALL_EVENTS)
  FIELD_ZMIN = CW_FIELD(MAIN13,TITLE = 'Min Depth', /FLOAT, VALUE = zmin, UVALUE = 'FIELD_ZMIN', /ALL_EVENTS)
  FIELD_ZMAX = CW_FIELD(MAIN13,TITLE = 'Max Depth', /FLOAT, VALUE = zmax, UVALUE = 'FIELD_ZMAX', /ALL_EVENTS)
  FIELD_QUALMIN = CW_FIELD(MAIN13,TITLE = 'Min Quality', /LONG, VALUE = qualmin, UVALUE = 'FIELD_QUALMIN', /ALL_EVENTS)
  FIELD_QUALMAX = CW_FIELD(MAIN13,TITLE = 'Max Quality', /LONG, VALUE = qualmax, UVALUE = 'FIELD_QUALMAX', /ALL_EVENTS)

  LABEL168 = WIDGET_LABEL( MAIN13, $
      UVALUE='LABEL168', $
      VALUE='')

  BUTTON_CANCEL = WIDGET_BUTTON( MAIN13, $
      UVALUE='BUTTON_CANCEL', $
      VALUE='Cancel')

  BUTTON_OK = WIDGET_BUTTON( MAIN13, $
      UVALUE='BUTTON_OK', $
      VALUE='Ok')

  WIDGET_CONTROL, MAIN13, /REALIZE


Ev=''

WHILE (Ev NE 'BUTTON_OK') AND (Ev NE 'BUTTON_CANCEL') DO BEGIN

Event=WIDGET_EVENT(MAIN13)

WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

CASE Ev OF

  'FIELD_MAGMIN': BEGIN
      magmin = event.value
      altered = 1
      END
  'FIELD_MAGMAX': BEGIN
      magmax = event.value
      altered = 1
      END
  'FIELD_ZMIN': BEGIN
      zmin = event.value
      altered = 1
      END
  'FIELD_ZMAX': BEGIN
      zmax = event.value
      altered = 1
      END
  'FIELD_QUALMIN': BEGIN
      qualmin = event.value
      altered = 1
      END
  'FIELD_QUALMAX': BEGIN
      qualmax = event.value
      altered = 1
      END
  'BUTTON_CANCEL': BEGIN
      END
  'BUTTON_OK': BEGIN
      END

ENDCASE

ENDWHILE

IF Ev EQ 'BUTTON_OK' THEN BEGIN


ENDIF ELSE  BEGIN

   magmin = magmin_old
   magmax = magmax_old

   zmin = zmin_old
   zmax = zmax_old

   qualmin = qualmin_old
   qualmax = qualmax_old

   altered=0

ENDELSE

IF DEFINED(MAIN13) THEN WIDGET_CONTROL,MAIN13,/DESTROY

RETURN

END

