;------------------------------------------------------------- 
;+ 
; NAME: 
;       RESULTOP 
; PURPOSE: 
;       Widget based interface for editing various plot - options, like MAINTITLE 
; MAIN PROGRAM: 
;       SLAP - program for testing SEISMOLAP 
;       SEISMOLAP was developed by Jochen Zschau, 
;       Geoforschungszentrum Potsdam, Germany 
; MODIFICATION HISTORY: 
;       Matthias Liebetanz, TH-Darmstadt, Germany, 17. Apr 1998 . 
; 
;       No warranty that this program is free of error 
;- 
;------------------------------------------------------------- 
FUNCTION RESULTOP, GROUP=group,$ 
                   INITIALIZE=INITIALIZE,$ 
                   QUAKE_LON=quake_lon,$ 
                   QUAKE_LAT=quake_lat,$ 
                   QUAKE_Z=quake_z,$ 
                   QUAKE_STRENGTH=quake_strength,$ 
                   QUAKE_JS=quake_js,$ 
                   MAINTITLE=maintitle,$ 
                   SUBTITLE=subtitle,$ 
                   FLAG_GIF=flag_gif,$ 
                   FLAG_PLOTSHOCK=flag_plotshock,$ 
                   FLAG_ANIMATION=flag_animation,$ 
                   SHOCK_TO_PLOT=info_shock,$ 
                   COLOR=color 
 
IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0 
 
IF KEYWORD_SET(INITIALIZE) THEN BEGIN 
   maintitle = 'SEISMOLAP Sapanca Earthquake M=4.2' 
   subtitle = '(Date: 9.12.88, Time: 14:24:42)' 
   flag_gif = 0 
   flag_animation = 0 
   flag_plotshock = 0 
   info_shock = 0 
   color = 27 ; Color table: EOS B 
   result = CREATE_STRUCT ( 'maintitle', maintitle, $ 
                            'subtitle', subtitle, $ 
                            'flag_gif', flag_gif, $ 
                            'flag_plotshock',flag_plotshock, $ 
                            'flag_animation',flag_animation, $ 
                            'shock_to_plot',info_shock, $ 
                            'color', color ) 
   RETURN, result 
ENDIF 
 
altered = 0 
 
  IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0 
 
  junk   = { CW_PDMENU_S, flags:0, name:'' } 
 
 
  MAIN13 = WIDGET_BASE(GROUP_LEADER=Group, $ 
      COLUMN=1, $ 
      MAP=1, $ 
      TITLE='Results options', $ 
      UVALUE='MAIN13') 
 
  FieldVal494 = [ $ 
    '' ] 
  FIELD_MAINTITLE = CW_FIELD( MAIN13,VALUE=FieldVal494, $ 
      ROW=1, $ 
      STRING=1, $ 
      ALL_EVENTS=1, $ 
      TITLE='Maintitle', $ 
      UVALUE='FIELD_MAINTITLE') 
 
  FieldVal496 = [ $ 
    '' ] 
  FIELD_SUBTITLE = CW_FIELD( MAIN13,VALUE=FieldVal496, $ 
      ROW=1, $ 
      STRING=1, $ 
      ALL_EVENTS=1, $ 
      TITLE='Subtitle..', $ 
      UVALUE='FIELD_SUBTITLE') 
 
  FieldVal178 = [ $ 
    '' ] 
  FIELD_COLOR = CW_FIELD( MAIN13,VALUE=FieldVal178, $ 
      ROW=1, $ 
      INTEGER=1, $ 
      ALL_EVENTS=1, $ 
      TITLE='Color table', $ 
      UVALUE='FIELD_COLOR') 
 
  LABEL30 = WIDGET_LABEL( MAIN13, $ 
      UVALUE='LABEL30', $ 
      VALUE='') 
 
  Btns499 = [ $ 
    'Write result pictures (GIF)' ] 
  BUTTON_FLAG_GIF = CW_BGROUP( MAIN13, Btns499, $ 
      NONEXCLUSIVE=1, $ 
      UVALUE='BUTTON_FLAG_GIF') 
 
  Btns500 = [ $ 
    'Plot selected event' ] 
  BUTTON_FLAG_PLOTSHOCK = CW_BGROUP( MAIN13, Btns500, $ 
      NONEXCLUSIVE=1, $ 
      UVALUE='BUTTON_FLAG_PLOTSHOCK') 
 
  Btns501 = [ $ 
    'Save animation (needs more memory)' ] 
  BUTTON_FLAG_ANIMATION = CW_BGROUP( MAIN13, Btns501, $ 
      NONEXCLUSIVE=1, $ 
      UVALUE='BUTTON_FLAG_ANIMATION') 
 
  LABEL27 = WIDGET_LABEL( MAIN13, $ 
      UVALUE='LABEL27', $ 
      VALUE='') 
 
  BUTTON_SELECT_EVENT =  WIDGET_BUTTON( MAIN13, $ 
      UVALUE='BUTTON_SELECT_EVENT', $ 
      VALUE='Select Event') 
 
  LABEL28 = WIDGET_LABEL( MAIN13, $ 
      UVALUE='LABEL28', $ 
      VALUE='') 
 
  BUTTON11 = WIDGET_BUTTON( MAIN13, $ 
      UVALUE='BUTTON_CANCEL', $ 
      VALUE='Cancel') 
 
  BUTTON12 = WIDGET_BUTTON( MAIN13, $ 
      UVALUE='BUTTON_OK', $ 
      VALUE='Ok') 
 
WIDGET_CONTROL, FIELD_MAINTITLE, SET_VALUE = maintitle 
WIDGET_CONTROL, FIELD_SUBTITLE, SET_VALUE = subtitle 
WIDGET_CONTROL, FIELD_COLOR, SET_VALUE = color 
WIDGET_CONTROL, BUTTON_FLAG_GIF, SET_VALUE = flag_gif 
WIDGET_CONTROL, BUTTON_FLAG_PLOTSHOCK, SET_VALUE = flag_plotshock 
WIDGET_CONTROL, BUTTON_FLAG_ANIMATION, SET_VALUE = flag_animation 
 
WIDGET_CONTROL, MAIN13, /REALIZE 
 
Ev='' 
 
WHILE (Ev NE 'BUTTON_OK') AND (Ev NE 'BUTTON_CANCEL') DO BEGIN 
 
Event=WIDGET_EVENT(MAIN13) 
 
WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev 
 
CASE Ev OF 
 
  'FIELD_MAINTITLE': BEGIN 
      maintitle = event.value 
      altered = 1 
      END 
  'FIELD_SUBTITLE': BEGIN 
      subtitle = event.value 
      altered = 1 
      END 
  'BUTTON_FLAG_GIF': BEGIN 
      flag_gif = event.select 
      altered = 1 
      END 
  'BUTTON_FLAG_PLOTSHOCK': BEGIN 
      IF NOT DEFINED(info_shock, /STRUCT) THEN BEGIN 
         error=WIDGET_MESSAGE('No event selected!',/ERROR) 
         WIDGET_CONTROL,BUTTON_FLAG_PLOTSHOCK,SET_VALUE=flag_plotshock 
      ENDIF ELSE BEGIN 
         flag_plotshock = event.select 
         altered = 1 
      ENDELSE 
      END 
 
  'BUTTON_FLAG_ANIMATION': BEGIN 
      flag_animation = event.select 
      altered = 1 
      END 
  'FIELD_COLOR': BEGIN 
      color = event.value 
      altered = 1 
      END 
  'BUTTON_SELECT_EVENT': BEGIN 
      IF KEYWORD_SET(DEFINED(info_shock,/STRUCT)) THEN BEGIN 
         yn = XDECISION([['There is already a selected event!'],$ 
                         ['Do You want to select a new one?']]) 
         IF STRUPCASE(yn) EQ 'N' THEN  GOTO,exit_button_event_select 
      ENDIF 
 
      MAINSHCK, ALTERED=altered_mainshocks, $ 
                QUAKE_LON=quake_lon,$ 
                QUAKE_LAT=quake_lat,$ 
                QUAKE_Z=quake_z,$ 
                QUAKE_STRENGTH=quake_strength,$ 
                QUAKE_JS=quake_js,$ 
                INFO_SHOCK=info_shock,$ 
                SELECTED_SCHOCK=selected_shock,$ 
                /SUPRESS_SWITCH 
 
      IF NOT altered_mainshocks THEN selected_shock = -1 
      IF NOT (selected_shock(0) EQ -1) THEN BEGIN 
         info_shock=CREATE_STRUCT('mag',info_shock.mag(selected_shock), $ 
                                  'lon',info_shock.lon(selected_shock), $ 
                                  'lat',info_shock.lat(selected_shock), $ 
                                  'z',info_shock.z(selected_shock), $ 
                                  'js',info_shock.js(selected_shock) ) 
         altered = 1 
      ENDIF 
      exit_button_event_select: 
      END 
  'BUTTON_CANCEL': BEGIN 
      END 
  'BUTTON_OK': BEGIN 
      END 
 
ENDCASE 
 
ENDWHILE 
 
IF Ev EQ 'BUTTON_OK' THEN BEGIN 
 
   IF altered THEN BEGIN 
 
      result = CREATE_STRUCT ( 'maintitle', maintitle, $ 
                               'subtitle', subtitle, $ 
                               'flag_gif', flag_gif, $ 
                               'flag_plotshock',flag_plotshock, $ 
                               'flag_animation',flag_animation, $ 
                               'shock_to_plot',info_shock, $ 
                               'color', color ) 
   ENDIF ELSE  result = 0 
 
ENDIF ELSE result = 0 
 
IF DEFINED(MAIN13) THEN WIDGET_CONTROL,MAIN13,/DESTROY 
 
RETURN,TEMPORARY(result) 
 
END 
