;-------------------------------------------------------------
;+
; NAME:
;       CW_SHOWTEXT
; PURPOSE:
;       Compound-Widget for Text-Display
; CATEGORY:
;       Widgets
; CALLING SEQUENCE:
;       CW_SHOWTEXT, PARENT, TEXT [,TITLE=TITLE] [,MODAL=MODAL]
; INPUTS:
;       PARENT=Id of Parent-widget of CW_SHOWTEXT.
;       TEXT=Text, to be displayed.
; KEYWORD PARAMETERS:
;       Keywords:
;       TITLE=If this keyword is set, the string becomes the title of the widged-window.
;       MODAL=If this keyword is set, CW_SHOWTEXT is blocking all further processing,
;       until it is destroyed.
; OUTPUTS:
; COMMON BLOCKS:
; NOTES:
; MODIFICATION HISTORY:
;       Matthias Liebetanz, 31 Mrz, 1997
;-
;-------------------------------------------------------------

PRO ShowTextBase_Event, Event                                    ; Event-Handler-Routine for CW_ShowText (see below)

  WIDGET_CONTROL,Event.Id,GET_UVALUE=Ev

  CASE Ev OF


  'ShowText.Ok-Button': BEGIN
    PRINT, 'Event for ShowText.Ok-Button'
       WIDGET_CONTROL, Event.Top,  /DESTROY                      ; Destroy application
       XMANAGER
    END

  ENDCASE
END



PRO CW_SHOWTEXT, Parent, Text, TITLE=title, MODAL=MODAL


      IF NOT KEYWORD_SET(TITLE) THEN title='CW_SHOWTEXT'

      ShowTextBase=WIDGET_BASE(GROUP_LEADER=parent, $
          TITLE=title, $
          /COLUMN, $
          MAP=1)

      BUTTON17 = WIDGET_BUTTON( ShowTextBase, $
          UVALUE='ShowText.Ok-Button', $
          VALUE='OK')

      TEXT11 = WIDGET_TEXT( ShowTextBase, VALUE=Text, $
          ALL_EVENTS=0, $
          /SCROLL, $
          UVALUE='ShowText.TextWidget', $
          YSIZE=20, $
          XSIZE=80)


      WIDGET_CONTROL,ShowTextBase,/REALIZE

      IF KEYWORD_SET(MODAL) THEN $
       XMANAGER, 'ShowTextBase', ShowTextBase, /MODAL $
       ELSE $
       XMANAGER, 'ShowTextBase', ShowTextBase

      END


